<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;
use illuminate\Support\Facades\Auth;
class CheckUserRole
{
    /**
     * Handle an incoming request.
     *
     * @param  \Closure(\Illuminate\Http\Request): (\Symfony\Component\HttpFoundation\Response)  $next
     */
    public function handle(Request $request, Closure $next, ...$roles): Response
    {
        if (Auth::check()) {
            // Check the user's role
            $user = Auth::user();
            if (in_array($user->role, $roles)) {
                return $next($request);
            } else {
                // User doesn't have the required role, log them out and then redirect
                Auth::logout();
                return redirect('/login');
            }
        }

        // Redirect to the login page
        return redirect('/');
        
    }
}
